--- old/usr/src/cmd/tar/tar.c	Sun Dec 14 23:31:20 2014
+++ new/usr/src/cmd/tar/tar.c	Sun Dec 14 23:31:20 2014
@@ -2646,7 +2646,7 @@
 convtoreg(off_t size)
 {
 	if ((size > 0) && (dblock.dbuf.typeflag != '0') &&
-	    (dblock.dbuf.typeflag != NULL) && (dblock.dbuf.typeflag != '1') &&
+	    (dblock.dbuf.typeflag != '\0') && (dblock.dbuf.typeflag != '1') &&
 	    (dblock.dbuf.typeflag != '2') && (dblock.dbuf.typeflag != '3') &&
 	    (dblock.dbuf.typeflag != '4') && (dblock.dbuf.typeflag != '5') &&
 	    (dblock.dbuf.typeflag != '6') && (dblock.dbuf.typeflag != 'A') &&
@@ -3159,7 +3159,7 @@
 					(void) unlink(namep);
 			}
 			linkp = templink;
-			if (*linkp !=  NULL) {
+			if (*linkp !=  '\0') {
 				if (Aflag && *linkp == '/')
 					linkp++;
 				if (link(linkp, namep) < 0) {
@@ -3200,7 +3200,7 @@
 					(void) unlink(namep);
 			}
 			linkp = templink;
-			if (*linkp != NULL) {
+			if (*linkp != '\0') {
 				if (Aflag && *linkp == '/')
 					linkp++;
 				if (link(linkp, namep) < 0) {
@@ -3249,7 +3249,7 @@
 					(void) unlink(namep);
 			}
 			linkp = templink;
-			if (*linkp != NULL) {
+			if (*linkp != '\0') {
 				if (Aflag && *linkp == '/')
 					linkp++;
 				if (link(linkp, namep) < 0) {
@@ -3389,10 +3389,10 @@
 			}
 		}
 		if (dblock.dbuf.typeflag == '0' ||
-		    dblock.dbuf.typeflag == NULL || convflag) {
+		    dblock.dbuf.typeflag == '\0' || convflag) {
 			delete_target(dirfd, comp, namep);
 			linkp = templink;
-			if (*linkp != NULL) {
+			if (*linkp != '\0') {
 				if (Aflag && *linkp == '/')
 					linkp++;
 				if (link(linkp, comp) < 0) {
@@ -3598,7 +3598,7 @@
 
 		if (pflag && newfile == TRUE && !dir &&
 		    (dblock.dbuf.typeflag == '0' ||
-		    dblock.dbuf.typeflag == NULL ||
+		    dblock.dbuf.typeflag == '\0' ||
 		    convflag || dblock.dbuf.typeflag == '1')) {
 			if (fstat(ofile, &xtractbuf) == -1)
 				(void) fprintf(stderr, gettext(
@@ -5485,7 +5485,7 @@
 
 	(void) strcpy(name, str);
 	while (name[strlen(name) - 1] == '/') {
-		name[strlen(name) - 1] = NULL;
+		name[strlen(name) - 1] = '\0';
 	}
 
 	h = hash(name);
@@ -5523,7 +5523,7 @@
 
 	(void) strcpy(name, str);
 	while (name[strlen(name) - 1] == '/') {
-		name[strlen(name) - 1] = NULL;
+		name[strlen(name) - 1] = '\0';
 	}
 
 	/*
@@ -5542,7 +5542,7 @@
 	 * check for any parent directories in the file list
 	 */
 	while ((ptr = strrchr(name, '/'))) {
-		*ptr = NULL;
+		*ptr = '\0';
 		h = hash(name);
 		exp = table[h];
 		while (exp != NULL) {
@@ -6615,7 +6615,7 @@
 					(void) unlinkat(fd, comp, 0);
 				} else if ((n = readlink(namep, buf,
 				    PATH_MAX)) != -1) {
-					buf[n] = (char)NULL;
+					buf[n] = '\0';
 					(void) unlinkat(fd, buf,
 					    AT_REMOVEDIR);
 					if (errno == ENOTDIR)
